//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License Version 2
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_PLUGIN_FLOW__BASE_HH 
#define BMP_PLUGIN_FLOW__BASE_HH 

#include <glibmm.h>
#include <gtkmm.h>

namespace Bmp
{
  typedef unsigned int RGUID;
  namespace Plugin
  {
      class FlowBase
      {
        public:
          FlowBase () {};
          virtual ~FlowBase () = 0;
          virtual bool 
          next (Glib::RefPtr<Gtk::ListStore> store, Gtk::TreeModel::iterator& iter) = 0;
          virtual bool 
          prev (Glib::RefPtr<Gtk::ListStore> store, Gtk::TreeModel::iterator& iter) = 0;
          virtual void
          reset () = 0; 
      };
  } 
}
  
#endif
